/*
*  AMX Mod X script
*
*	TFC Modification of MaximumBroods Easteregg plugin
*
*	by Lt Llama
*
*  WHAT IS THIS?
*  ====================
*	This is a modification for tfc of MaximumBroods easteregg plugin for CS
*	which you can find here: http://forums.alliedmods.net/showthread.php?p=230526.
*	CS has money, TFC has nothing, so what to give the TFC players in present?
*	Only thing we could think of was custom models.
*	So! Admins can with this plugin spawn christmas trees and presents.
*	The trees are just eye candy but the presents give, when touched, a menu to chose
*	some custom models from. Admins with rcon can also place spawn points so the trees
*	an presents are spawned on map change.
*
*  INSTALLATION
*  ============
*	_ Put the player models in your tfc/player folder
*	_ Put tree.mdl, present1.mdl and present2.mdl in your tfc/models folder.
*
*  SETTINGS YOU MAY CHANGE
*  =======================
*  	Change to whatever you like under "// Customizable globals" below and recompile.
*	sv_eastereggamount = the amount of presents you want to spawn when amx_addspawnpoint is used
*	sv_treeamount = the amount of trees you want to spawn when amx_addtreespawnpoint is used
*	sv_removepresents = allows admins to remove all spawned trees and presents
*	sv_newpresent = the time limit before someone can pick up a new present
*
*  USER COMMANDS
*	amx_spawnpresent = spawn a present where you stand
*	amx_spawntree = spawn a christmas tree where you stand
*	amx_remove = remove all spawned stuff
*	amx_addspawnpoint = add a spawn point for presents to config file
*	amx_addtreespawnpoint = add a spawn point for christmas trees to config file
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <tfcx> 

#define MAXSPAWNS 64
#define MAXPRESENTS 10
#define MAXTREES 10
#define TOTALCOLORS 10

new nPresents
new nTrees
new Float:origins[MAXSPAWNS][3] //origins for presents
new Float:origins2[MAXSPAWNS][3] //origins for trees
new bool:hasPresent[33] //bool to check if the guy has a present

new totalOrigins
new totalOrigins2
new tfcclass[33] //holds tfc classes for players

new Float:colors[TOTALCOLORS][3] = {
	{95.0, 200.0, 255.0},
	{0.0, 150.0, 255.0},
	{180.0, 255.0, 175.0},
	{0.0, 155.0, 0.0},
	{255.0, 255.0, 255.0},
	{255.0, 190.0, 90.0},
	{222.0, 110.0, 0.0},
	{192.0, 192.0, 192.0},
	{190.0, 100.0, 10.0},
	{0.0, 0.0, 0.0}
}

public plugin_init() {
	register_plugin("Christmas plugin", "0.1", "MaximusBrood (version for TFC by Lt Llama)")
	// Llama: changed command names
	register_clcmd("amx_spawnpresent", "cmd_Spawn", ADMIN_KICK, "Spawns a present!") 
	register_clcmd("amx_spawntree", "cmd_Spawntree", ADMIN_KICK, "Spawns a christmas tree!")
	register_clcmd("amx_remove", "cmd_Remove", ADMIN_KICK, "Removes all presents")
	register_clcmd("amx_addspawnpoint", "cmd_AddSpawn", ADMIN_RCON, "Adds a new spawnlocation to file")
	register_clcmd("amx_addtreespawnpoint", "cmd_AddTreeSpawn", ADMIN_RCON, "Adds a new tree spawnlocation to file")
	
	register_cvar("sv_eastereggamount", "3")
	register_cvar("sv_treeamount", "1") // Llama: you probably only want one tree at that spot :)
	register_cvar("sv_newpresent", "120.0") // Llama: the time before you can pick a new present
	
	register_touch("MaxBrood_easteregg", "player", "presentTouch")
	register_menucmd(register_menuid("viewmenu"),((1<<0)|(1<<1)|(1<<2)|(1<<3)), "viewmenuenter") // Llama: to menu to chose model
	register_menucmd(register_menuid("modelmenu"),((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<9)), "modelmenuenter") // Llama: to menu to chosem model
	LoadData()
}

// Llama: precaches for models (maybe add a global var for the current server admin)
public plugin_precache() {
	precache_model("models/euroskillz/present1.mdl")
	precache_model("models/euroskillz/present2.mdl")
	precache_model("models/euroskillz/tree.mdl")
	precache_model("models/player/santa/santa.mdl")
	precache_model("models/player/dave/dave.mdl")
	precache_model("models/player/homer/homer.mdl")
	precache_model("models/player/luigi/luigi.mdl")
	precache_model("models/player/pacman/pacman.mdl")
	precache_model("models/player/panther/panther.mdl")
	precache_model("models/player/penguin/penguin.mdl")
	precache_model("models/player/domokun/domokun.mdl")
	return PLUGIN_CONTINUE
}

// Clear the tasks and cvars attached to id's
public client_disconnect(id) {
	new authid[32] ; get_user_authid(id,authid,31)
	if (task_exists(id)) remove_task(id)
	hasPresent[id] = false
}

// Llama: some tweeks to spawn both trees and presents
public LoadData() {
	//Reset totalOrigins
	totalOrigins = 0
	totalOrigins2 = 0
	
	//Load the spawndata for presents
	new datadir[64], filepath[64], mapname[32]
	get_datadir(datadir, 63)
	get_mapname(mapname, 31)
	format(filepath, 63, "%s/%s_presents.ini", datadir, mapname)
	
	if(file_exists(filepath))
		{
		new line, len, output[256]
		for(line = 0; line < MAXSPAWNS && read_file(filepath, line, output, 255, len); line++)
			{
			if(output[0] == ';' || !output[0]) 
				continue;
			
			new x[16], y[16], z[16]
			parse(output, x, 15, y, 15, z, 15)
			
			origins[totalOrigins][0] = float(str_to_num(x))
			origins[totalOrigins][1] = float(str_to_num(y))
			origins[totalOrigins][2] = float(str_to_num(z))
			
			//Increment totalOrigins
			totalOrigins++
		}
	}
	//Load the spawndata for trees
	new datadir2[64], filepath2[64], mapname2[32]
	get_datadir(datadir2, 63)
	get_mapname(mapname2, 31)
	format(filepath2, 63, "%s/%s_tree.ini", datadir2, mapname2)
	
	if(file_exists(filepath2))
		{
		new line2, len2, output2[256]
		for(line2 = 0; line2 < MAXSPAWNS && read_file(filepath2, line2, output2, 255, len2); line2++)
			{
			if(output2[0] == ';' || !output2[0]) 
				continue;
			
			new g[16], h[16], i[16]
			parse(output2, g, 15, h, 15, i, 15)
			
			origins2[totalOrigins2][0] = float(str_to_num(g))
			origins2[totalOrigins2][1] = float(str_to_num(h))
			origins2[totalOrigins2][2] = float(str_to_num(i))
			
			//Increment totalOrigins2
			totalOrigins2++
		}
	}	
	
	//Retrieve amount of presents
	new presentAmount = get_cvar_num("sv_eastereggamount")
	new data[3]
	
	for(new a = 0; a < totalOrigins; a++)
		{
		FVecIVec(origins[a], data)
		
		for(new b = 0; b < presentAmount; b++) {
			CreateEnt(data)
		}
	}
	//Retrieve amount of trees
	new treeAmount = get_cvar_num("sv_treeamount")
	new data2[3]
	
	for(new j = 0; j < totalOrigins2; j++) {
		FVecIVec(origins2[j], data2)
		for(new k = 0; k < treeAmount; k++) {
			CreateTreeEnt(data2)
		}
	}
}

//---------------------------------------------------------------------------
//                               COMMANDS
//---------------------------------------------------------------------------

// Llama: manual command to add present spawns (i know! could be merged with cmd_AddTreeSpawn)
public cmd_AddSpawn(id, level, cid)
	{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	
	//We need to add a spawn, first locate output file
	new datadir[64], filepath[64], mapname[32]
	get_datadir(datadir, 63)
	get_mapname(mapname, 31)
	format(filepath, 63, "%s/%s_presents.ini", datadir, mapname)
	
	new totallines
	totallines = file_size(filepath, 1)
	
	//Check if total number of lines doesn't exeed the maxspawns
	if(totallines > MAXSPAWNS)
		{
		client_print(id, print_console, "[MaxBrood] %L", id, "MAXSPAWNS_REACHED", MAXSPAWNS)
		return PLUGIN_HANDLED
	}
	
	new x, y, z, totaltext[16]
	new Float:curOrigin[3]
	
	//Get current location
	entity_get_vector(id, EV_VEC_origin, curOrigin)
	
	//Makes them ready for integer transport
	x = floatround(curOrigin[0])
	y = floatround(curOrigin[1])
	z = floatround(curOrigin[2])
	
	//Write the area at end of file and exit
	format(totaltext, 15, "%d %d %d", x, y, z)
	write_file(filepath, totaltext)
	
	client_print(id, print_chat, "[MaxBrood] %L", id, "ADD_SUCCESS")
	client_print(id, print_console, "[MaxBrood] %L", id, "ADD_SUCCESS")
	
	//Reload renewed data
	LoadData()
	
	return PLUGIN_HANDLED
}

// Llama: manual command to add tree spawns (i know! could be merged with cmd_AddSpawn)
public cmd_AddTreeSpawn(id, level, cid)	{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	
	//We need to add a spawn, first locate output file
	new datadir[64], filepath[64], mapname[32]
	get_datadir(datadir, 63)
	get_mapname(mapname, 31)
	format(filepath, 63, "%s/%s_tree.ini", datadir, mapname)
	
	new totallines
	totallines = file_size(filepath, 1)
	
	//Check if total number of lines doesn't exeed the maxspawns
	if(totallines > MAXSPAWNS) {
		client_print(id, print_console, "[MaxBrood] %L", id, "MAXSPAWNS_REACHED", MAXSPAWNS)
		return PLUGIN_HANDLED
	}
	
	new x, y, z, totaltext[16]
	new Float:curOrigin[3]
	
	//Get current location
	entity_get_vector(id, EV_VEC_origin, curOrigin)
	
	//Makes them ready for integer transport
	x = floatround(curOrigin[0])
	y = floatround(curOrigin[1])
	z = floatround(curOrigin[2])
	
	//Write the area at end of file and exit
	format(totaltext, 15, "%d %d %d", x, y, z)
	write_file(filepath, totaltext)
	
	client_print(id, print_chat, "[MaxBrood] %L", id, "ADD_SUCCESS")
	client_print(id, print_console, "[MaxBrood] %L", id, "ADD_SUCCESS")
	
	//Reload renewed data
	LoadData()
	
	return PLUGIN_HANDLED
}

// Llama: manual command to add a present
public cmd_Spawn(id, level, cid) {
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	if (nPresents > 0) {
		if (nPresents == MAXPRESENTS) {
			client_print(id, print_chat, "You cant add any more presents. Use amx_remove to clear and add again")
			return PLUGIN_CONTINUE
		}
		if (nPresents == MAXPRESENTS)
			return PLUGIN_HANDLED
		
	}
	nPresents = nPresents + 1

	new Float:curOrigin[3]
	entity_get_vector(id, EV_VEC_origin, curOrigin)
	
	//Convert the origins for transport
	new data[3]
	FVecIVec(curOrigin, data)
	
	set_task(2.5, "CreateEnt", 0, data, 3)
	new name[32]
	get_user_name(id, name, 31)
	client_print(0, print_chat, "Santa admin %s is making some presents", name)
	return PLUGIN_HANDLED
}

// Llama: manual command to add a tree
public cmd_Spawntree(id, level, cid)
	{
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	if (nTrees > 0) {
		if (nTrees == MAXTREES) {
			client_print(id, print_chat, "You cant add any more trees. Max %i. Use amx_remove to clear and add again",MAXTREES)
			return PLUGIN_CONTINUE
		}
		if (nTrees == MAXTREES)
			return PLUGIN_HANDLED
		
	}
	nTrees = nTrees + 1
	
	new Float:curOrigin[3]
	entity_get_vector(id, EV_VEC_origin, curOrigin)
	
	//Convert the origins for transport
	new data[3]
	FVecIVec(curOrigin, data)
	
	set_task(2.5, "CreateTreeEnt", 0, data, 3)
	new name[32]
	get_user_name(id, name, 31)
	client_print(0, print_chat, "Santa admin %s is making a christmas tree", name)	
	return PLUGIN_HANDLED
}
// Llama: Removes all spawned stuff
public cmd_Remove(id, level, cid) {
	if (!cmd_access(id, level, cid, 1))
		return PLUGIN_HANDLED
	
	removeAll()
	
	//client_print(id, print_chat, "[MaxBrood] %L", id, "REMOVED_ALL")
	//client_print(id, print_console, "[MaxBrood] %L", id, "REMOVED_ALL")
	
	return PLUGIN_HANDLED
}

// Llama: Message to client when he can pick a new present
public newPresent(id) {
	hasPresent[id] = false
	client_print(id, print_chat, "Happy Christmas! You can get a new present now")
}

//---------------------------------------------------------------------------
//                                  EVENTS
//---------------------------------------------------------------------------

// Llama: Event when present touched
public presentTouch(pToucher, pTouched) {
	//Check if player is connected and check if both player and egg are valid entities
	if (hasPresent[pTouched])
		return PLUGIN_HANDLED
	nPresents = nPresents - 1
	if(!is_valid_ent(pToucher) || !is_valid_ent(pTouched) || !is_user_connected(pTouched))
		return PLUGIN_HANDLED
	modelmenu(pTouched)
	//Remove the egg
	remove_entity(pToucher)
	client_print(pTouched, print_chat, "Happy Christmas! You can come back for a new present in %i seconds", floatround(get_cvar_float("sv_newpresent")))
	hasPresent[pTouched] = true
	set_task(get_cvar_float("sv_newpresent"), "newPresent",pTouched)
	return PLUGIN_CONTINUE
}

//---------------------------------------------------------------------------
//                               BACKBONE
//---------------------------------------------------------------------------

//It always acts in a certain order
new currmodel = 1

// Llama: Create the present ent
public CreateEnt(data[3]) {
	//Unpack the origin
	new Float:origin[3]
	IVecFVec(data, origin) 
	
	new ent = create_entity("info_target")
	new Float:velocity[3]
	velocity[0] = float(random(256) - 128)
	velocity[1] = float(random(256) - 128)
	velocity[2] = float(random(300) + 75)
	
	//Set random model
	new filename[40]
	currmodel = currmodel > 1 ? 1 : ++currmodel
	format(filename, 39, "models/euroskillz/present%d.mdl", currmodel)
	
	//YEEY, cookie is mine!!! but shit, its an easteregg :(
	entity_set_string(ent, EV_SZ_classname, "MaxBrood_easteregg")
	
	//Colors
	new rand = random_num(0, TOTALCOLORS - 1)
	
	if(random_num(1, 10) == 5)
		entity_set_int(ent, EV_INT_renderfx, kRenderFxHologram)
	
	entity_set_int(ent, EV_INT_renderfx, kRenderFxGlowShell)
	entity_set_float(ent, EV_FL_renderamt, 1000.0)
	entity_set_int(ent, EV_INT_rendermode, kRenderTransAlpha)
	entity_set_vector(ent, EV_VEC_rendercolor, colors[rand])
	
	//Set all the properties to the present
	entity_set_model(ent, filename)
	entity_set_origin(ent, origin)
	entity_set_int(ent, EV_INT_effects, 32)
	entity_set_int(ent, EV_INT_solid, SOLID_TRIGGER)
	entity_set_int(ent, EV_INT_movetype, MOVETYPE_TOSS)
	entity_set_vector(ent, EV_VEC_velocity, velocity)
	
	return PLUGIN_HANDLED
}  

// Llama: Create the tree
public CreateTreeEnt(data2[3]) {
	//Unpack the origin
	new Float:origin2[3]
	IVecFVec(data2, origin2) 
	
	new ent2 = create_entity("info_target")
	new Float:velocity[3]
	velocity[0] = float(random(256) - 128)
	velocity[1] = float(random(256) - 128)
	velocity[2] = float(random(300) + 75)
	
	//Set the tree model
	new filename[32]
	format(filename, 31, "models/euroskillz/tree.mdl")
	
	//YEEY, cookie is mine!!! but shit, its an easteregg :(
	entity_set_string(ent2, EV_SZ_classname, "MaxBrood_tree")
	
	//Colors
	new rand = random_num(0, TOTALCOLORS - 1)
	
	if(random_num(1, 10) == 5)
		entity_set_int(ent2, EV_INT_renderfx, kRenderFxHologram)
	
	entity_set_int(ent2, EV_INT_renderfx, kRenderFxGlowShell)
	entity_set_float(ent2, EV_FL_renderamt, 1000.0)
	entity_set_int(ent2, EV_INT_rendermode, kRenderTransAlpha)
	entity_set_vector(ent2, EV_VEC_rendercolor, colors[rand])
	//Set all the properties to the tree
	entity_set_model(ent2, filename)
	entity_set_origin(ent2, origin2)
	entity_set_int(ent2, EV_INT_effects, 32)
	entity_set_int(ent2, EV_INT_solid, SOLID_TRIGGER)
	entity_set_int(ent2, EV_INT_movetype, MOVETYPE_TOSS)
	entity_set_vector(ent2, EV_VEC_velocity, velocity)
	return PLUGIN_HANDLED
}  

// Llama: Menu items whne you pick a present
public modelmenu(id){ // modelmenu
	show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)|(1<<4)|(1<<5)|(1<<6)|(1<<7)|(1<<8)|(1<<9)),"Happy Christmas! Chose a present^n1: Santa^n2: Dave^n3: Homer^n4: Luigi^n5: Pacman^n6: Panther^n7: Penguin^n8: Domukun^n0: Reset to default", -1, "modelmenu")
}

// Executed when choices done in the model menu
// Llama: Goodies to chose from when you picked a present
public modelmenuenter(id,key){
	new name[32]
	get_user_name(id, name, 31)
	switch (key)
	{
		case 0: // key 1
		{
			tfc_setmodel (id, "santa","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"Ho Ho Ho says Santa %s",name)
			client_print(id, print_chat, "You have chosen to be Santa")
			viewmenu(id)
		}
		case 1: // key 2
		{
			tfc_setmodel (id, "dave","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is happy Dave now",name)
			client_print(id, print_chat, "You have chosen to be Dave")
			viewmenu(id)
		}
		case 2: // key 3
		{
			tfc_setmodel (id, "homer","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is Homer now",name)
			client_print(id, print_chat, "You have chosen to be Homer")			
			viewmenu(id)
		}
		case 3: // key 4
		{
			tfc_setmodel (id, "luigi","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is Luigi now",name)
			client_print(id, print_chat, "You have chosen to be Luigi")			
			viewmenu(id)
		}
		case 4: // key 5
		{
			tfc_setmodel (id, "pacman","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is Pacman now ",name)
			client_print(id, print_chat, "You have chosen to be Pacman")						
			viewmenu(id)
		}
		case 5: // key 6
		{
			tfc_setmodel (id, "panther","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is Panther now ",name)
			client_print(id, print_chat, "You have chosen to be Panther")						
			viewmenu(id)
		}
		case 6: // key 7
		{
			tfc_setmodel (id, "penguin","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is Penguin now ",name)
			client_print(id, print_chat, "You have chosen to be Penguin")
			viewmenu(id)
		}
		case 7: // key 8
		{
			tfc_setmodel (id, "domokun","0") 
			set_hudmessage(200,0,0, 0.03, 0.76, 2, 0.02, 1.0, 0.01, 0.1, 2)
			show_hudmessage(0,"%s is Domukun now ",name)
			client_print(id, print_chat, "You have chosen to be Domukun")
			viewmenu(id)
		}
		case 9: // key 9
		{
			client_print(id, print_chat, "Ok! No presents for you grumpy face ;)")
			tfcclass[id] = get_user_class(id)
			// // Llama: Reset the model if client chose 0 in menu
			if (tfcclass[id] == 1)
				tfc_setmodel (id, "scout","0")
			else if (tfcclass[id] == 2)
				tfc_setmodel (id, "sniper","0")
			else if (tfcclass[id] == 3)
				tfc_setmodel (id, "soldier","0")
			else if (tfcclass[id] == 4)
				tfc_setmodel (id, "demoman","0")
			else if (tfcclass[id] == 5)
				tfc_setmodel (id, "medic","0")
			else if (tfcclass[id] == 6)
				tfc_setmodel (id, "hvyweapon","0")
			else if (tfcclass[id] == 7)
				tfc_setmodel (id, "pyro","0")
			else if (tfcclass[id] == 8)
				tfc_setmodel (id, "spy","0")
			else if (tfcclass[id] == 9)
				tfc_setmodel (id, "engineer","0")
			else
				tfc_setmodel (id, "civilian","0")
			viewmenu(id)
		}
	}
}

// Llama: Menu item to chose views
public viewmenu(id) { // view menu
	show_menu(id,((1<<0)|(1<<1)|(1<<2)|(1<<3)),"View yourself^n1: Third person^n2: Top down^n3: Up left^n4: Back to game", -1, "viewmenu")
}

// Llama: Selected views
public viewmenuenter(id,key) {
	switch (key) {
		case 0:
		{
			set_view(id,CAMERA_3RDPERSON)
			viewmenu(id)
		}
		
		case 1:
		{
			set_view(id,CAMERA_TOPDOWN)
			viewmenu(id)
		}
		
		case 2:
		{
			set_view(id,CAMERA_UPLEFT)
			viewmenu(id)
		}
		case 3:
		{
			set_view(id,CAMERA_NONE)
		}
	}
}

// Llama: Remove all stuff
public removeAll() {
	new ent
	new ent2
	nTrees = 0
	nPresents = 0
	while ( (ent = find_ent_by_class(ent, "MaxBrood_easteregg")) != 0) {
		remove_entity(ent)
	}
	while ( (ent2 = find_ent_by_class(ent2, "MaxBrood_tree")) != 0) {
		remove_entity(ent2)
	}
	return;
}

// Gets the player class
// Llama: Stock to get TFC player classes for resetting clas models
stock get_user_class(id) {
	new playerclass = entity_get_int(id, EV_INT_playerclass)
	return playerclass
}
